<?php
/*
Plugin Name: Wordpress ICS Importer
Plugin URI: http://www.fullimpact.net/
Version: v1.0
Author: <a href="http://www.fullimpact.net/">Daniel Olfelt</a>
Description: A plugin for importing ICS files from Google or iCal that contains a GUI and many configurations.
*/
//ini_set('display_errors', 1); // FOR DEBUGING ONLY

require_once('import_ical.php');
require_once('ics-functions.php');

if (!class_exists("WPICSImporter")) {
	class WPICSImporter {
		var $adminOptionsName 			= "ICSAdminOptions";
		var $showCalendar               = "show-ics-calendar";
		function WPICSImporter() { //constructor
			
		}
		
		function init() {
			$this->getAdminOptions();
		}
		
		function getAdminOptions() {
			$ICSAdminOptions = array(
				'ics_file' 				=> '',
				'title' 				=> 'ICS Calendar',
				'event_limit'	 		=> '15',
				'time_format' 			=> 'g:i a',
				'date_format' 			=> 'D, M j',
				'custom_format' 		=> '',
				'gmt_start' 			=> '',
				'gmt_end' 				=> '',
				'gmt_start_now' 		=> 'true',
				'cache_time'	 		=> '86400',
				'use_custom_format' 	=> 'false',
				'widget_event_limit' 	=> '5',
				'widget_title' 			=> 'Upcoming Events'
				);
			$icsOptions = get_option($this->adminOptionsName);
			if (!empty($icsOptions)) {
				foreach ($icsOptions as $key => $option)
					$ICSAdminOptions[$key] = $option;
			}
			update_option($this->adminOptionsName, $ICSAdminOptions);
			
			return $ICSAdminOptions;
		}
		function printAdminPage() {
			$icsOptions = $this->getAdminOptions();
			if (isset($_POST['update_ICSImporterSettings'])) {

				$icsOptions['ics_file'] = $_POST['icsFile'];
				$icsOptions['title'] = $_POST['icsTitle'];
				$icsOptions['event_limit'] = $_POST['icsEventLimit'];
				$icsOptions['cache_time'] = $_POST['icsCacheTime'];
				$icsOptions['time_format'] = $_POST['icsTimeFormat'];
				$icsOptions['date_format'] = $_POST['icsDateFormat'];
				$icsOptions['gmt_start'] = $_POST['icsGmtStart'];
				$icsOptions['gmt_end'] = $_POST['icsGmtEnd'];
				$icsOptions['gmt_start_now'] = $_POST['icsGmtStartNow'];
				$icsOptions['custom_format'] = $_POST['icsCustomFormat'];
				$icsOptions['use_custom_format'] = $_POST['icsUseCustomFormat'];

				if(class_exists('ICalEvents')) {
					ICalEvents::update_cache($icsOptions['ics_file']);
				}
				
				update_option($this->adminOptionsName, $icsOptions);
				
				?>
				<div class="fade updated" id="message"><p><strong><?php _e("Settings Updated.", "WPICSImporter");?></strong></p></div>
				<?php
			} ?>
			
			<div class=wrap>
			<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
			<h2>Wordpress ICS Import</h2>
			<table cellpadding="0" cellspacing="0" width="100%">
			<tr><td colspan="2">
				<h3>Events Calendar Title</h3>
				<input type="text" name="icsTitle" style="width: 80%; " value="<?php _e(stripslashes($icsOptions['title']), 'WPICSImporter') ?>" />
			</td></tr><tr><td colspan="2">
				<h3>URL to ICS File</h3>
				<input type="text" name="icsFile" style="width: 80%; " value="<?php _e($icsOptions['ics_file'], 'WPICSImporter') ?>" />
			</td></tr><tr><td valign="top">
				<h3>Event Display Limit</h3>
				<input type="text" name="icsEventLimit" style="width: 10%; " value="<?php _e($icsOptions['event_limit'], 'WPICSImporter') ?>" /> Set to "0" to show all events.
				<br /><br /><br /><br />
				</td><td valign="top">
				<h3>Calendar Update Delay</h3>
				<input disabled="disabled" type="text" name="icsCacheTime" style="width: 10%; " value="<?php _e($icsOptions['cache_time'], 'WPICSImporter') ?>" /> Seconds
				<br /><small>Set to 1 day. [Feature coming soon.]</small>
			</td></tr><tr><td colspan="2">
				<h3>Current Event Display</h3>
				<p><label for="icsGmtStartNow_yes"><input type="checkbox" id="icsGmtStartNow_yes" name="icsGmtStartNow" value="true" <?php if ($icsOptions['gmt_start_now'] == "true") { _e('CHECKED', "WPICSImporter"); }?> /> Show only upcoming event. (Only events in the future.)</label></p>
				From <input type="text" name="icsGmtStart" style="width: 100px; " value="<?php _e($icsOptions['gmt_start'], 'WPICSImporter') ?>" /> to
				<input type="text" name="icsGmtEnd" style="width: 100px; " value="<?php _e($icsOptions['gmt_end'], 'WPICSImporter') ?>" />
				<br /><small>Use format 'YYYY-MM-DD' or 'YYYY-MM-DD HH:MM:SS'. This is irrelevant if the Upcoming Events box is checked. Leave these blank if you want to show all events.</small>
			</td></tr><tr><td valign="top">
				<h3>Time Format</h3>
				<input type="text" name="icsTimeFormat" style="width: 20%; " value="<?php _e($icsOptions['time_format'], 'WPICSImporter') ?>" /> <small>Uses PHP <a target="_blank" href="http://us3.php.net/manual/en/function.date.php">Date Function</a>.</small>
				</td><td valign="top">
				<h3>Date Format</h3>
				<input type="text" name="icsDateFormat" style="width: 20%; " value="<?php _e($icsOptions['date_format'], 'WPICSImporter') ?>" /> <small>Uses PHP <a target="_blank" href="http://us3.php.net/manual/en/function.date.php">Date Function</a>.</small>
			</td></tr><tr><td valign="top">
				<h3>Use Custom Format</h3>
				<p><label for="icsUseCustomFormat_yes"><input type="radio" id="icsUseCustomFormat_yes" name="icsUseCustomFormat" value="true" <?php if ($icsOptions['use_custom_format'] == "true") { _e('checked="checked"', "WPICSImporter"); }?> /> Yes</label>	<label for="icsUseCustomFormat_no"><input type="radio" id="icsUseCustomFormat_no" name="icsUseCustomFormat" value="false" <?php if ($icsOptions['use_custom_format'] == "false") { _e('checked="checked"', "WPICSImporter"); }?>/> No</label></p>
				</td><td valign="top">
				<h3>Custom Format</h3>
				<textarea name="icsCustomFormat" style="width: 40%; height:100px; "><?php _e($icsOptions['custom_format'], 'WPICSImporter') ?></textarea>
				<br />Use <i>%date-time%</i>, <i>%event-title%</i>, <i>%description%</i> and <i>%location%</i>.
			</td></tr><tr><td colspan="2"><br /><br />
				To use this on a <b>Page</b>, enter <b>show-ics-calendar</b> as a custom field at the bottom of the page. Place anything in the value field. It means nothing.
			
			</td></tr><tr><td colspan="2">
			<div class="submit"><input type="submit" name="update_ICSImporterSettings" value="<?php _e('Update Settings', 'WPICSImporter') ?>" /></div>
			</td></tr></table>
			</form>
			</div>
			<?php
		}
		
		function placePageCalendar($content) {
			// Only do this if this is a page and it has the appropriate custom field
			if (is_page()) {
				$custFieldValues = get_post_custom_values($this->showCalendar);
				if ($custFieldValues != NULL) {
					$event_limit = $custFieldValues[0];
					$icsOptions = $this->getAdminOptions();
					if($icsOptions['use_custom_format']=='true') {
						$content = ICalEvents::custom_display_events($icsOptions);
					} else {
						if($icsOptions['gmt_start_now']=='true') {
							$gmt_start = time();
							$gmt_end = NULL;
						} else {
							if($options['gmt_start']!='') $gmt_start = strtotime($options['gmt_start'], time());
							if($options['gmt_end']!='') $gmt_end = strtotime($options['gmt_end'], time());
						}
						define('ICAL_EVENTS_CACHE_TTL', $icsOptions['cache_time']);
						$content = ICalEvents::display_events($icsOptions['ics_file'], 'limit='.$icsOptions['event_limit'].'&date_format='.$icsOptions['date_format'].'&time_format='.$icsOptions['time_format'].'&use_description=1&use_location=1&gmt_start='.$gmt_start.'&gmt_end='.$gmt_end);
					}
				}
			}
			return $content;
		}
		
		function getWidgetContents($widget) {
			$output = '';
			
			
			return $output;
		}
		
		### SIDEBAR WIDGET COMPILE INFORMATION
		
		function widgetICSImporterInit() {
			if (!function_exists('register_sidebar_widget')) { return; }
			
			//$options = $this->getAdminOptions();
			
			function widgetICSImporter($args) {
				global $dl_pluginICS;
				
				if (!isset($dl_pluginICS)) { return; }
				
				if(!$widget = get_option('ICSWidgetOptions')) $widget = array('widget_event_limit'=>'5', 
																			  'widget_title'=>'Upcoming Events', 
																			  'widget_link'=>'', 
																			  'date_format'=>'', 
																			  'time_format'=>'',
																			  'hide_time'=>'',
																			  'gmt_start_now'=>'true');
				
				
				$options = $dl_pluginICS->getAdminOptions();
				$options['event_limit'] = $widget['widget_event_limit'];
				$options['use_custom_format'] = 'false';
				$options['hide_time'] = $widget['hide_time'];
				
				if($widget['date_format']!='') $options['date_format'] = $widget['date_format'];
				if($widget['time_format']!='') $options['time_format'] = $widget['time_format'];
				if($widget['gmt_start_now']=='true') $options['gmt_start_now'] = 'true';
				
				$options['custom_format'] = '<li style="color:#333333; "><b>%date-time%:</b>%event-title%</li>';
				
				print $before_widget . $before_title;
				print "<h2>".$widget['widget_title'].'</h2><ul>';	
				print $after_title;		
				print ICalEvents::custom_display_events($options);
				if($widget['widget_link']!='') {
					print '<small><a href="'.$widget['widget_link'].'">More &raquo;</a></small>';
				}
				print "</ul>".$after_widget;
				
			}
			
			function widgetICSImporterOptions()
			{
		
				//$options = $this->getAdminOptions();
				if(!$options = get_option('ICSWidgetOptions')) $options = array('widget_event_limit'=>'5', 
																				'widget_title'=>'Upcoming Events', 
																				'widget_link'=>'', 
																				'date_format'=>'', 
																				'time_format'=>'',
																				'hide_time'=>'',
																				'gmt_start_now'=>'true');
				
				if($_POST['icsImporterSubmit'])
				{
					$options['widget_event_limit'] = $_POST['icsWidgetEventLimit'];
					$options['widget_title'] = $_POST['icsWidgetTitle'];
					$options['date_format'] = $_POST['icsWidgetDateFormat'];
					$options['time_format'] = $_POST['icsWidgetTimeFormat'];
					$options['widget_link'] = $_POST['icsWidgetLink'];
					$options['hide_time'] = $_POST['icsWidgetHideTime'];
					$options['gmt_start_now'] = $_POST['icsWidgetGmtStartNow'];
					update_option('ICSWidgetOptions', $options);
		
				}
				?>
		
				<p>Title: <input type="text" name="icsWidgetTitle" value="<?php echo $options['widget_title']; ?>" id="icsWidgetTitle" /></p>
				<p>Event Limit: <input type="text" name="icsWidgetEventLimit" value="<?php echo $options['widget_event_limit']; ?>" id="icsWidgetEventLimit" /></p>
				<label for="icsWidgetGmtStartNow_checked"><input type="checkbox" id="icsWidgetGmtStartNow_checked" name="icsWidgetGmtStartNow" value="true"<?php if ($options['gmt_start_now'] == "true") { echo ' CHECKED'; }?> /> Show upcoming events only.</label>
				<p>Date Format: <input type="text" name="icsWidgetDateFormat" value="<?php echo $options['date_format']; ?>" id="icsWidgetDateFormat" /><br />
				<small>Default will be used if not set.</small></p>
				<p>Time Format: <input type="text" name="icsWidgetTimeFormat" value="<?php echo $options['time_format']; ?>" id="icsWidgetTimeFormat" /><br />
				<label for="icsWidgetHideTime_checked"><input type="checkbox" id="icsWidgetHideTime_checked" name="icsWidgetHideTime" value="true"<?php if ($options['hide_time'] == "true") { echo ' CHECKED'; }?> /> Do not display time.</label>
				<br /><small>Default will be used if not set.</small></p>
				<p>Bottom Link: <input type="text" name="icsWidgetLink" value="<?php echo $options['widget_link']; ?>" id="icsWidgetLink" /><br />
				<small>Will be used at the bottom of the events.</small></p>

				<input type="hidden" id="icsImporterSubmit" name="icsImporterSubmit" value="1" />
				
				<?php
		
			}
			register_sidebar_widget('ICS Import', 'widgetICSImporter');
			register_widget_control('ICS Import', 'widgetICSImporterOptions', 300, 370);
		}
	
	}
}

if (class_exists("WPICSImporter")) {
	$dl_pluginICS = new WPICSImporter();
}

//Actions and Filters
if (isset($dl_pluginICS)) {
	if (!function_exists("ICSImporter_ap")) {
		function ICSImporter_ap() {
			global $dl_pluginICS;
			if (!isset($dl_pluginICS)) {
				return;
			}
			if (function_exists('add_options_page')) {
				add_options_page('Wordpress ICS Import', 'ICS Import', 9, basename(__FILE__), array(&$dl_pluginICS, 'printAdminPage'));
			}
		}
	}
	//Actions
	add_action('admin_menu', 'ICSImporter_ap');
	add_action('activate_ical-events/ical-events.php',  array(&$dl_pluginICS, 'init'));
	add_action('plugins_loaded', array(&$dl_pluginICS, 'widgetICSImporterInit'));
	//add_action('wp_head', array(&$dl_pluginICS, 'addHeaderCode'), 1);
	//Filters
	add_filter('the_content', array(&$dl_pluginICS, 'placePageCalendar'), '7');
}


?>